; -*- fundamental -*-
;
; ABC80 project test ROM image
;
_start			; Reset entry point
	ld sp,#0xfffe

	call (say_hello)	; Test call/ret

	; Test memory
	ld de,#0x8000
	ld hl,hello_msg
	ld bc,#13
	ldir

	; Transfer it to video memory
	ld de,(r40l1)
	ld hl,#0x8000
	ld bc,#32
	ldir

	; Copy within video memory
	ld de,(r40l2)
	ld hl,(r40l0)
	ld bc,#32
	ldir

	; Program PIO
	ld a,#0xFF		; Mode 3
	out (#57),a
	out (#57),a

	; Read keys and print them on screen
	ld ix,r40l0
new_row
	ld l,(ix+0)
	ld h,(ix+1)
	ld b,#40

key_char
	in a,(#56)
	call (show)
	cp #0x80
	jr c,key_char
	and #0x7F
	ld (hl),a
	inc hl
wait_key
	in a,(#56)
	call (show)
	cp #0x80
	jr nc,wait_key

	djnz key_char

	inc ix
	inc ix
	jr new_row

die
	halt
	jr die

show
	push af
	push bc
	push hl
	ld hl,(r40l23)
	ld b,#8
show_loop
	rlca
	ld c,a
	and #1
	or #0x30
	ld (hl),a
	inc hl
	ld a,c
	djnz show_loop
	pop hl
	pop bc
	pop af
	ret

say_hello
	ld de,(r40l0)
	ld hl,hello_msg
	ld bc,#13
	ldir
	ret

hello_msg
	byte "Hello, World!"
	byte 0

rowtbl40
r40l0
	word 0x7c00 ; row 0
r40l1
	word 0x7c80 ; row 1
r40l2
	word 0x7d00 ; row 2
r40l3
	word 0x7d80 ; row 3
r40l4
	word 0x7e00 ; row 4
r40l5
	word 0x7e80 ; row 5
r40l6
	word 0x7f00 ; row 6
r40l7
	word 0x7f80 ; row 7
r40l8
	word 0x7c28 ; row 8
r40l9
	word 0x7ca8 ; row 9
r40l10
	word 0x7d28 ; row 10
r40l11
	word 0x7da8 ; row 11
r40l12
	word 0x7e28 ; row 12
r40l13
	word 0x7ea8 ; row 13
r40l14
	word 0x7f28 ; row 14
r40l15
	word 0x7fa8 ; row 15
r40l16
	word 0x7c50 ; row 16
r40l17
	word 0x7cd0 ; row 17
r40l18
	word 0x7d50 ; row 18
r40l19
	word 0x7dd0 ; row 19
r40l20
	word 0x7e50 ; row 20
r40l21
	word 0x7ed0 ; row 21
r40l22
	word 0x7f50 ; row 22
r40l23
	word 0x7fd0 ; row 23
rowtbl80
r80l0
	word 0x7800 ; row 0
r80l1
	word 0x7900 ; row 1
r80l2
	word 0x7a00 ; row 2
r80l3
	word 0x7b00 ; row 3
r80l4
	word 0x7c00 ; row 4
r80l5
	word 0x7d00 ; row 5
r80l6
	word 0x7e00 ; row 6
r80l7
	word 0x7f00 ; row 7
r80l8
	word 0x7850 ; row 8
r80l9
	word 0x7950 ; row 9
r80l10
	word 0x7a50 ; row 10
r80l11
	word 0x7b50 ; row 11
r80l12
	word 0x7c50 ; row 12
r80l13
	word 0x7d50 ; row 13
r80l14
	word 0x7e50 ; row 14
r80l15
	word 0x7f50 ; row 15
r80l16
	word 0x78a0 ; row 16
r80l17
	word 0x79a0 ; row 17
r80l18
	word 0x7aa0 ; row 18
r80l19
	word 0x7ba0 ; row 19
r80l20
	word 0x7ca0 ; row 20
r80l21
	word 0x7da0 ; row 21
r80l22
	word 0x7ea0 ; row 22
r80l23
	word 0x7fa0 ; row 23
